import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["step"];
import { Children, useState, useEffect } from 'react';
import cx from 'classnames';
import PropTypes from 'prop-types';
import MoleculeStepper, { moleculeStepperDesign, moleculeStepperAlignment, Step } from '@s-ui/react-molecule-stepper';
import { BASE_CLASS, CLASS_CONTENT, CLASS_VERTICAL, CLASS_COMPRESSED, PROGRESS_BAR_JUSTIFY_CONTENT, CONTENT_STYLE } from './config.js';
import MoleculeProgressStep, { STATUSES } from './components/MoleculeProgressStep/index.js';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";

var MoleculeProgressSteps = function MoleculeProgressSteps(_ref) {
  var _cx;

  var vertical = _ref.vertical,
      children = _ref.children,
      iconStepDone = _ref.iconStepDone,
      compressed = _ref.compressed,
      _ref$progressBarJusti = _ref.progressBarJustifyContent,
      progressBarJustifyContent = _ref$progressBarJusti === void 0 ? PROGRESS_BAR_JUSTIFY_CONTENT.LEGACY : _ref$progressBarJusti,
      _ref$contentStyle = _ref.contentStyle,
      contentStyle = _ref$contentStyle === void 0 ? CONTENT_STYLE.FIXED : _ref$contentStyle,
      onChange = _ref.onChange;

  var _useState = useState(),
      step = _useState[0],
      setStep = _useState[1];

  var className = cx(BASE_CLASS, (_cx = {}, _cx[CLASS_VERTICAL] = vertical, _cx[CLASS_COMPRESSED] = compressed, _cx));
  useEffect(function () {
    if (children) {
      var currentStep = Children.toArray(children).filter(Boolean).map(function (child, index, elements) {
        return child.props.status;
      }).lastIndexOf(STATUSES.ACTIVE);
      var lastVisitedStep = Children.toArray(children).filter(Boolean).map(function (child, index, elements) {
        return child.props.status;
      }).lastIndexOf(STATUSES.VISITED);
      var steps = Children.toArray(children).filter(Boolean).length;

      if (currentStep >= 0 && step !== currentStep) {
        setStep(currentStep);
      } else if (steps - 1 === lastVisitedStep && step !== steps) {
        setStep(steps);
      } else if (lastVisitedStep === -1 && currentStep === -1) {
        setStep(-1);
      }
    }
  }, [children, step]);

  var onChangeHandler = function onChangeHandler(event, _ref2) {
    var step = _ref2.step,
        args = _objectWithoutPropertiesLoose(_ref2, _excluded);

    typeof onChange === 'function' && onChange(event, _extends({
      step: step
    }, args));
  };

  return /*#__PURE__*/_jsxs("div", {
    className: className,
    children: [children && /*#__PURE__*/_jsx(MoleculeStepper, {
      steps: Children.toArray(children).length,
      step: step,
      visitedIcon: iconStepDone,
      labels: Children.toArray(children).filter(Boolean).map(function (_ref3) {
        var _ref3$props = _ref3.props;
        _ref3$props = _ref3$props === void 0 ? {} : _ref3$props;
        var label = _ref3$props.label,
            index = _ref3.index;
        return label;
      }),
      justifyContent: progressBarJustifyContent,
      design: compressed ? moleculeStepperDesign.COMPRESSED : moleculeStepperDesign.DEFAULT,
      alignment: vertical ? moleculeStepperAlignment.VERTICAL : moleculeStepperAlignment.HORIZONTAL,
      onChange: onChangeHandler,
      children: Children.toArray(children).filter(Boolean).map(function (child, index, elements) {
        var _child$props, _child$props2, _child$props3;

        return /*#__PURE__*/_jsx(Step, {
          steps: elements.length,
          step: index + 1,
          visited: index < step,
          current: step === index,
          label: child == null ? void 0 : (_child$props = child.props) == null ? void 0 : _child$props.label,
          icon: child == null ? void 0 : (_child$props2 = child.props) == null ? void 0 : _child$props2.icon,
          currentIcon: child == null ? void 0 : (_child$props3 = child.props) == null ? void 0 : _child$props3.iconActive
        }, index);
      })
    }), /*#__PURE__*/_jsx("div", {
      className: cx(CLASS_CONTENT, contentStyle),
      children: Children.toArray(children).filter(Boolean).map(function (child, index) {
        var _cx2;

        var _child$props4 = child.props,
            childrenChild = _child$props4.children,
            status = _child$props4.status;
        return /*#__PURE__*/_jsx("div", {
          className: cx(CLASS_CONTENT + "-item", (_cx2 = {}, _cx2[CLASS_CONTENT + "-item--active"] = status === STATUSES.ACTIVE, _cx2)),
          children: childrenChild
        }, index);
      })
    })]
  });
};

MoleculeProgressSteps.displayName = 'MoleculeProgressSteps';
export default MoleculeProgressSteps;
export { MoleculeProgressStep, STATUSES, STATUSES as moleculeProgressStepsStatuses, PROGRESS_BAR_JUSTIFY_CONTENT as moleculeProgressStepsJustifyContentBar, CONTENT_STYLE as moleculeProgressContentStyle };